/* 8051 diassembler interface
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef DISASM8051_H__
#define DISASM8051_H__

#include <stdint.h>

#include <lib.h>

BEGIN_C_DECLS

/* Disassemble INSN at PC, store opcode to *OPCODE (max. 5 chars,
   not to be freed), operands to BUF (64 chars);
   returns: number of bytes in instruction */
extern size_t i8051_disasm (uint16_t pc, const uint8_t *insn,
			    const char **opcode, char *buf);

END_C_DECLS

#endif
