/* Bit value widget -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCBITEDIT_H__
#define KCBITEDIT_H__

#include <qvalidator.h>

#include "kcporteditbase.h"

struct expr_code;
class KCMainWin;

class KCBitEdit: public KCPortEditBase
{ 
  Q_OBJECT
public:
  KCBitEdit (QWidget *parent = 0, const char* name = 0);
  ~KCBitEdit ();
  /** Set control to bit of expr with name */
  void setBit (const QString &name, const QString &expr, unsigned bit);
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Set KCMainWin to task to update all views to win */
  void setMainWin (KCMainWin *win);

protected slots:
  /** Try to modify the bit according to user's change */
  void editAcceptChanges ();
  /** Edit gained focus */
  void editFocusGained ();

private:
  struct expr_code *compiled;
  QString expr_;
  KCMainWin *mainWin;
  unsigned bit_;
  bool modifying;
};

#endif
