/* Breakpoint window item -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCBREAKITEM_H__
#define KCBREAKITEM_H__

#include <klistview.h>
#include <qstring.h>

struct breakpoint;

class KCBreakItem: public KListViewItem
{
public:
  KCBreakItem (QListView *parent, const QString &expression);
  ~KCBreakItem ();
  QString text (int column) const;
  /** Change breakpoint expression, compile it and compute current value */
  void setExpression (const QString &expression);
  /** @returns breakpoint expression */
  QString expression () const;
  /** Recompute value and possibly repaint */
  void cerealUpdate ();
  
private:
  struct breakpoint *bp;
  bool triggered;
};

#endif
