/* Expression input dialog -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCWATCHDIALOG_H__
#define KCWATCHDIALOG_H__

#include <qstring.h>

#include "kcexprdialogbase.h"

class QListView;

class KCExprDialog: public KCExprDialogBase
{
  Q_OBJECT
public:
  /** Create an "input expression" dialog with given title and initial
      expression */
  KCExprDialog (QWidget *parent, const QString &title,
		const QString &expression);
  ~KCExprDialog ();
  /** Get current expression value */
  QString expression () const;

protected slots:
  /** expressionText has changed */
  void expressionChanged ();
};

#endif
