/* Expresion line edit control
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <klineedit.h>

#include <port.h>

#include "kcexprlineedit.h"
#include "kcinsertportdialog.h"

KCExprLineEdit::KCExprLineEdit (QWidget *parent, const char *name, WFlags f)
  : KCExprLineEditBase (parent, name, f)
{
}

KCExprLineEdit::~KCExprLineEdit ()
{
}

/** Get current expression text */
QString
KCExprLineEdit::text () const
{
  return exprText->text ();
}

void
KCExprLineEdit::setText (const QString &s)
{
  exprText->setText (s);
}

void
KCExprLineEdit::exprTextChanged (const QString &s)
{
  emit textChanged (s);
}

void
KCExprLineEdit::portClicked ()
{
  KCInsertPortDialog *dlg = new KCInsertPortDialog (this, PORT_TYPE_DISPLAY);
  if (dlg->exec () == QDialog::Accepted)
    exprText->insert (QString ("[%1]").arg (dlg->selectedPortName ()));
  delete dlg;
}

#include "kcexprlineedit.moc"
