/* Expresion line edit control -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCEXPRLINEEDIT_H__
#define KCEXPRLINEEDIT_H__

#include <qstring.h>

#include "kcexprlineeditbase.h"

/* The interface is as KLineEdit-compatible as possible, but it's just an
   internal tool, so most of the interfaces are not directly available.
   If you need them, pull them out ;-)
   Qt doesn't handle tab order of nested widgets well. You can fix that
   by manually calling setTabOrder of the nested widgets. So much for
   object encapsulation... */
class KCExprLineEdit: public KCExprLineEditBase
{
  Q_OBJECT
public:
  KCExprLineEdit (QWidget *parent = 0, const char *name = 0, WFlags f = 0);
  ~KCExprLineEdit ();
  /** Get current expression text */
  QString text () const;

public slots:
  virtual void setText (const QString &s);

signals:
  void textChanged (const QString &s);

protected slots:
  void exprTextChanged (const QString &s);
  void portClicked ();
};

#endif
