/* Insert Port Reference dialog -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCINSERTPORTDIALOG_H__
#define KCINSERTPORTDIALOG_H__

#include <qstring.h>

#include <module.h>
#include <port.h>

#include "kcinsertportdialogbase.h"

class KCInsertPortDialog: public KCInsertPortDialogBase
{
  Q_OBJECT
public:
  /** Create an "insert port reference" dialog for port type */
  KCInsertPortDialog (QWidget *parent, int type);
  ~KCInsertPortDialog ();
  /** @returns port name selected by user */
  QString selectedPortName () const;

protected slots:
  /** Module has changed */
  void moduleChanged ();
  /** Space has changed */
  void spaceChanged ();
  /** Port has changed */
  void portChanged ();

private:
  int type_;
  /** Modify space list according to other selections, try to preserve
      currently selected item */
  void rebuildSpace ();
  /** Modify port list according to other selections, try to preserve currently
      selected item */
  void rebuildPort ();
  /** Update state of OKButton according to other selections */
  void rebuildOK ();
  /** Currently we are rebuilding some of the controls, so ignore selection
      changes */
  bool changing;
  /** Currently selected connection parameters from the combobox values */
  enum port_width width;
  struct port_id pi;
};

#endif
