/* KLineEdit with additional signals
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include "kclineedit.h"

KCLineEdit::KCLineEdit (const QString &string, QWidget *parent,
			const char *name)
  : KLineEdit (string, parent, name)
{
}

KCLineEdit::KCLineEdit (QWidget *parent, const char *name)
  : KLineEdit (parent, name)
{
}
KCLineEdit::~KCLineEdit ()
{
}

/** Emit focusGained () */
void
KCLineEdit::focusInEvent (QFocusEvent *event)
{
  emit focusGained ();
  KLineEdit::focusInEvent (event);
}

/** Emit focusLost () */
void
KCLineEdit::focusOutEvent (QFocusEvent *event)
{
  emit focusLost ();
  KLineEdit::focusOutEvent (event);
}

#include "kclineedit.moc"
