/* KLineEdit with additional signals -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCLINEEDIT_H__
#define KCLINEEDIT_H__

#include <klineedit.h>

class KCLineEdit: public KLineEdit
{
  Q_OBJECT
public:
  KCLineEdit (const QString &string, QWidget *parent = 0,
	      const char *name = 0);
  KCLineEdit (QWidget *parent = 0, const char *name = 0);
  ~KCLineEdit ();

signals:
  /** This window has lost focus */
  void focusLost ();
  /** This window has gained focus */
  void focusGained ();

protected:
  /** Emit focusGained () */
  void focusInEvent (QFocusEvent *event);
  /** Emit focusLost () */
  void focusOutEvent (QFocusEvent *event);
};

#endif
