/* KListView with additional signals
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include "kclistview.h"

KCListView::KCListView (QWidget *parent, const char *name)
  : KListView (parent, name)
{
}

KCListView::~KCListView ()
{
}

/** Handle Insert and Delete keys */
void
KCListView::keyPressEvent (QKeyEvent *event)
{
  if (event->key () == Qt::Key_Insert)
    {
      emit insertPressed ();
      event->accept ();
    }
  else if (event->key () == Qt::Key_Delete && selectedItem () != 0)
    {
      emit deletePressed ();
      event->accept ();
    }
  else
    KListView::keyPressEvent (event);
}

/** Emit focusGained () */
void
KCListView::focusInEvent (QFocusEvent *event)
{
  emit focusGained ();
  KListView::focusInEvent (event);
}

/** Emit focusLost () */
void
KCListView::focusOutEvent (QFocusEvent *event)
{
  emit focusLost ();
  KListView::focusOutEvent (event);
}

#include "kclistview.moc"
