/* Port value widget -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCPORTEDIT_H__
#define KCPORTEDIT_H__

#include "kcporteditbase.h"

struct expr_code;
class KCMainWin;

class KCPortEdit: public KCPortEditBase
{ 
  Q_OBJECT
public:
  KCPortEdit (QWidget *parent = 0, const char* name = 0);
  ~KCPortEdit ();
  /** Set control to expr with name */
  void setExpression (const QString &name, const QString &expr);
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Set KCMainWin to task to update all views to win */
  void setMainWin (KCMainWin *win);
  
signals:
  /** The edit box in KCPortEdit widget has gained focus */
  void focusGained (QWidget *widget);

protected slots:
  /** Try to modify the port according to user's change */
  void editAcceptChanges ();
  /** Edit gained focus */
  void editFocusGained ();

private:
  struct expr_code *compiled;
  QString expr_;
  KCMainWin *mainWin;
  bool modifying;
};

#endif
