/* Select Module dialog -*-c++-*-
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <klistbox.h>
#include <kpushbutton.h>
#include <kstdguiitem.h>

#include <me.h>

#include "kcselectmoduledialog.h"

/** Create an "select module" dialog for module type */
KCSelectModuleDialog::KCSelectModuleDialog (QWidget *parent,
					    const struct cereal_module *type)
  : KCSelectModuleDialogBase (parent)
{
  cancelButton->setGuiItem (KStdGuiItem::cancel ());
  OKButton->setGuiItem (KStdGuiItem::ok ());

  for (const struct me_entry *me = me_list; me != NULL; me = me->next)
    {
      if (me->module == type)
	moduleList->insertItem (me->name);
    }
  moduleList->sort ();
  QListBoxItem *first = moduleList->firstItem ();
  if (first != 0)
    {
      moduleList->setCurrentItem (first);
      moduleList->setSelected (first, false);
    }
  
  OKButton->setEnabled (false);
}

KCSelectModuleDialog::~KCSelectModuleDialog ()
{
}

/** @returns module selected by user */
struct me_entry *
KCSelectModuleDialog::selectedModule () const
{
  if (moduleList->currentItem () == -1)
    return NULL;
  return me_find (moduleList->currentText ());
}

/** Return key was pressed */
void
KCSelectModuleDialog::returnPressed ()
{
  if (moduleList->currentItem () != -1)
    accept ();
}

/** moduleList selection has changed */
void
KCSelectModuleDialog::selectionChanged ()
{
  OKButton->setEnabled (moduleList->currentItem () != -1);
}

#include "kcselectmoduledialog.moc"
