/* Watch window item -*-c++-*-
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCWATCHITEM_H__
#define KCWATCHITEM_H__

#include <klistview.h>
#include <qstring.h>

struct expr_code;

class KCWatchItem: public KListViewItem
{
public:
  KCWatchItem (QListView *parent, const QString &expression);
  ~KCWatchItem ();
  QString text (int column) const;
  /** Change watch expression, compile it and compute current value */
  void setExpression (const QString &expression);
  /** @returns watch expression */
  QString expression () const { return expression_; };
  /** Recompute value and possibly repaint */
  void cerealUpdate ();
  
private:
  QString expression_, value;
  struct expr_code *code;
};

#endif
