/* Abstract base class for cereal view windows
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */


#include "kcmainwin.h"
#include "kcwindow.h"

/** Register itself in mainWin_ */
KCWindow::KCWindow (QWidget *widget_, KCWindowProvider *provider_,
		    const QString &name_, KCMainWin *mainWin_)
  : widget (widget_), provider (provider_), name (name_), mainWin (mainWin_)
{
  mainWin->registerView (this);
}

/** Unregister itself in mainWin */
KCWindow::~KCWindow ()
{
  mainWin->unregisterView (this);
}
