/* Abstract base class for cereal view windows -*-c++-*-
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCWINDOW_H__
#define KCWINDOW_H__

#include <qstring.h>

struct _xmlNode;
class KCMainWin;
class KCWindowProvider;
class QWidget;

class KCWindow
{
public:
  /** Register itself in mainWin_ */
  KCWindow (QWidget *widget_, KCWindowProvider *provider_,
	    const QString &name_, KCMainWin *mainWin_);
  /** Unregister itself in mainWin */
  virtual ~KCWindow ();
  /** Update view because emulation state has changed */
  virtual void cerealUpdate () = 0;
  /** Save current UI state under uiState */
  virtual void saveState (struct _xmlNode *uiState) = 0;
  QWidget *const widget;
  KCWindowProvider *provider; /* May be 0 */
  const QString name;
private:
  KCMainWin *mainWin;
};

#endif

