/* Abstract base class for modules providing cereal view windows -*-c++-*-
   Copyright (C) 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KCWINDOWPROVIDER_H__
#define KCWINDOWPROVIDER_H__

class QStringList;
class QWidget;

class KCWindowProvider
{
 public:
  /** @return list of names of windows that can be created by
      provideWindow () */
  virtual QStringList providedWindowList () = 0;
  /** Create a window corresponding to member i of the list returned by
      providedWindowList () */
  virtual void provideWindow (unsigned i) = 0;
};

#endif
