/* 8051 cereal_kde plugin -*-c++-*-
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KC8051_H__
#define KC8051_H__

#include <kparts/plugin.h>

#include "../kde/kcuistatehandler.h"
#include "../kde/kcwindowprovider.h"

/* Our XML namespace */
extern const char KC8051XMLNs[];

struct cereal_module;
class KCMainWin;

class KC8051:
  public KParts::Plugin, private KCUIStateHandler, private KCWindowProvider
{
  Q_OBJECT
public:
  KC8051 (QObject *parent = 0, const char *name = 0);
  ~KC8051 ();
  /** Save current UI state under uiState */
  void saveState (struct _xmlNode *uiState);
  /** Load UI state from uiState of doc;
      returns: 0 if OK, -1 on error */
  int loadState (struct _xmlDoc *doc, struct _xmlNode *uiState);
  /** @return list of names of windows that can be created by
      provideWindow () */
  QStringList providedWindowList ();
  /** Create a window corresponding to member i of the list returned by
      providedWindowList () */
  void provideWindow (unsigned i);
  
private slots:
  /** 8051/Load Program was selected */
  void loadProgram ();

private:
  /** 8051 module */
  const struct cereal_module *i8051_module;
  /** KCMainWin we are attached to */
  KCMainWin *mainWin;
};

#endif
