/* 8051 plugin factory
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <kinstance.h>

#include "kc8051.h"
#include "kc8051factory.h"

KC8051Factory::KC8051Factory (QObject *parent, const char *name)
  : KLibFactory (parent, name)
{
  instance = new KInstance ("KC8051Factory");
}

KC8051Factory::~KC8051Factory ()
{
  delete instance;
}

QObject *
KC8051Factory::createObject (QObject *parent, const char *name, const char *,
			     const QStringList &)
{
  QObject *obj = new KC8051 (parent, name);
  emit objectCreated (obj);
  return obj;
}

KInstance *KC8051Factory::instance = 0;

extern "C" void *
init_libkc8051 ()
{
  return new KC8051Factory;
}

#include "kc8051factory.moc"
