/* Connection delete dialog
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <kpushbutton.h>
#include <kstdguiitem.h>
#include <qcheckbox.h>

#include "khwdeleteconnectiondialog.h"

KHwDeleteConnectionDialog::KHwDeleteConnectionDialog (QWidget *parent)
  : KHwDeleteConnectionDialogBase (parent)
{
  yesButton->setGuiItem (KStdGuiItem::yes ());
  noButton->setGuiItem (KStdGuiItem::no ());
}

KHwDeleteConnectionDialog::~KHwDeleteConnectionDialog ()
{
}

/** Enable/disable deletePeerCheckbox */
void
KHwDeleteConnectionDialog::setDeletePeerEnabled (bool enabled)
{
  deletePeerCheckbox->setEnabled (enabled);
}

/** Check/uncheck deletePeerCheckbox */
void
KHwDeleteConnectionDialog::setDeletePeerChecked (bool checked)
{
  deletePeerCheckbox->setChecked (checked);
}

/** Is deletePeerCheckbox checked? */
bool
KHwDeleteConnectionDialog::deletePeerChecked () const
{
  return deletePeerCheckbox->isChecked ();
}
