/* MI list view, which allows deleting using Delete key
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <klistview.h>
#include <klocale.h>
#include <qevent.h>
#include <qlistview.h>
#include <qnamespace.h>

#include <me.h>
#include <module.h>

#include "khwmilist.h"

KHwMiList::KHwMiList (QWidget *parent, const char *name)
  : KListView (parent, name)
{
  addColumn (i18n ("Name"));
  addColumn (i18n ("Type"));
  setItemsRenameable (true);
  reload ();
}

KHwMiList::~KHwMiList ()
{
}

/** Reload contents from me_list */
void
KHwMiList::reload ()
{
  clear ();
  for (const struct me_entry *me = me_list; me != NULL; me = me->next)
    /* We need to store the original name before renaming, so there is
       a hidden column. */
    new KListViewItem (this, me->name, me->module->name, me->name);
  QListViewItem *first = firstChild ();
  if (first != 0)
    {
      setCurrentItem (first);
      setSelected (first, false);
    }
}

/** Handle Delete key */
void
KHwMiList::keyPressEvent (QKeyEvent *event)
{
  if (event->key () == Qt::Key_Delete && selectedItem () != 0)
    {
      emit deletePressed ();
      event->accept ();
    }
  else
    KListView::keyPressEvent (event);
}

#include "khwmilist.moc"
