/* Item/Properties dialog -*-c++-*-
   Copyright (C) 2002, 2004 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#ifndef KHWPROPERTIESDIALOG_H__
#define KHWPROPERTIESDIALOG_H__

#include <qmap.h>

#include "khwpropertiesdialogbase.h"

struct connect_entry;
struct me_entry;
class KHwConnListItem;

class KHwPropertiesDialog: public KHwPropertiesDialogBase
{
  Q_OBJECT
public:
  KHwPropertiesDialog (QWidget *parent, struct me_entry *me_);
  ~KHwPropertiesDialog ();

protected slots:
  /** connection selection has changed */
  void connectionSelectionChanged ();
  /** Delete selected connection */
  void deleteConnection ();
  /** Modify selected connection */
  void modifyConnection();
  /** Create a new connection */
  void newConnection();
  /** Option selection has changed */
  void optionSelectionChanged ();
  /** Tab was switched */
  void tabSwitched (QWidget *);
  /** Check if optionValue is OK, and accept () if so */
  void tryAccept ();

private:
  /** Set prev_option to optionValue.  @returns true on success */
  bool setOption ();
  /** Find KHwConnListItem for conn */
  KHwConnListItem *findConn (const struct connect_entry *conn);
  /** Rebuild connectionList */
  void rebuildConnectionList ();
  struct me_entry *me;
  QListViewItem *prev_option;
  QMap<QString, QString> descriptions;
  bool modified;
  QString last_err_val;
  QListViewItem *last_err_option;
};

#endif
