/* get_num ()
   Copyright (C) 2002 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */
#include <config.h>

#include <errno.h>
#include <stdlib.h>

#include <lib.h>

/* Parse a number-only argument STRING with strtoul-like BASE, store result
   to *RES;
   returns: 0 if OK, -1 on error */
int
get_num (const char *string, int base, unsigned long *res)
{
  unsigned long val;
  char *tail;

  errno = 0;
  val = strtoul (string, &tail, base);
  if (tail == string || *tail != 0 || errno != 0)
    {
      error (0, "`%s' is not a valid number", string);
      return -1;
    }
  *res = val;
  return 0;
}
