/* get_xml_enum ()
   Copyright (C) 2002, 2005 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <string.h>
#include <libxml/tree.h>

#include <lib.h>

/* Load *VAL from xml element NODE of DOC, containing one of NUM STRINGS;
   returns: 0 if OK, -1 on error */
int
get_xml_enum (struct _xmlDoc *doc, struct _xmlNode *node,
	      const char *const *strings, size_t num, unsigned *val)
{
  xmlChar *str;
  const char *const *p;

  str = xmlNodeListGetString (doc, node->children, 1);
  if (str == NULL)
    goto err;
  for (p = strings; p < strings + num; p++)
    {
      if (strcmp (*p, (const char *)str) == 0)
	{
	  *val = p - strings;
	  xmlFree (str);
	  return 0;
	}
    }
 err:
  xmlFree (str);
  error (0, "invalid enumeration value");
  return -1;
}
