/* get_xml_num ()
   Copyright (C) 2002, 2004, 2005 Miloslav Trmac <mitr@volny.cz>

   You can redistribute and/or modify this program under the terms of the
   GNU General Public License version 2 as published by the Free Software
   Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place Suite 330, Boston, MA 02111-1307, USA. */

#include <libxml/tree.h>

#include <lib.h>

/* Parse unsigned number from xml NODE of DOC in range [0, limit), store
   result to *RES;
   returns: 0 if OK, -1 on error */
int
get_xml_num (xmlDocPtr doc, xmlNodePtr node, unsigned long limit,
	     unsigned long *res)
{
  xmlChar *str;
  int ret;
  
  str = xmlNodeListGetString (doc, node->children, 1);
  if (str == NULL)
    {
      ret = -1;
      goto err;
    }
  ret = get_num ((char *)str, 0, res);
  xmlFree (str);
  if (ret != 0)
    goto err;
  if (*res >= limit)
    {
      /* Not that much helpful, but helpful enough if you modify the state
	 files by hand. */
      error (0, "value %lu in XML file is not smaller than %lu", *res, limit);
      ret = -1;
      goto err;
    }
 err:
  return ret;
}
