/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse expre_parse
#define yylex   expre_lex
#define yyerror expre_error
#define yylval  expre_lval
#define yychar  expre_char
#define yydebug expre_debug
#define yynerrs expre_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUM = 258,
     LSH = 259,
     RSH = 260,
     LEQ = 261,
     GEQ = 262,
     EQ = 263,
     NEQ = 264,
     LAND = 265,
     LOR = 266,
     UNEG = 267,
     UPLUS = 268
   };
#endif
#define NUM 258
#define LSH 259
#define RSH 260
#define LEQ 261
#define GEQ 262
#define EQ 263
#define NEQ 264
#define LAND 265
#define LOR 266
#define UNEG 267
#define UPLUS 268




/* Copy the first part of user declarations.  */
#line 16 "../main/expr_parse.y"

#include <config.h>

#include <assert.h>
#include <errno.h>
#include <inttypes.h>  
#include <stdlib.h>
#include <string.h>

#include <expr.h>
#include <lib.h>
#include <port.h>

#include "expr_code.h"
  
/* Parser information */
struct pi
{
  const char *expr; /* Current position in parsed expression */
  struct expr_code *start, *code, *end;
  unsigned flags; /* See EC_* in <expr.h> */
};

/* Semantic data type */
struct semantic
{
  /* In NUM, there was an error evaluating the port referece, so call YYABORT
     when possible */
  int err; 
};

#define YYSTYPE struct semantic

#define YYPARSE_PARAM pi_
#define YYLEX_PARAM pi_
#define YYERROR_VERBOSE
 
static void expre_error (const char *s);
static int expre_lex (YYSTYPE *lvalp, void *pi_);

/* Add OP to expression */
static void expre_add_op (struct pi *pi, int op);
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 166 "main/expr_parse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  43
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   59

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  29
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  15
/* YYNRULES -- Number of rules. */
#define YYNRULES  38
/* YYNRULES -- Number of states. */
#define YYNSTATES  66

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   268

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    24,     2,     2,     2,    23,    16,     2,
      27,    28,    21,    19,     2,    20,     2,    22,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    13,     2,
      17,     2,    18,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    15,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    14,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    25,    26
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    14,    17,    20,    22,
      26,    30,    34,    36,    40,    44,    46,    50,    54,    56,
      60,    64,    68,    72,    74,    78,    82,    84,    88,    90,
      94,    96,   100,   102,   106,   108,   112,   114,   120
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      43,     0,    -1,     3,    -1,    27,    42,    28,    -1,    30,
      -1,    19,    31,    -1,    20,    31,    -1,    24,    31,    -1,
      31,    -1,    32,    21,    31,    -1,    32,    22,    31,    -1,
      32,    23,    31,    -1,    32,    -1,    33,    19,    32,    -1,
      33,    20,    32,    -1,    33,    -1,    34,     4,    33,    -1,
      34,     5,    33,    -1,    34,    -1,    35,    17,    34,    -1,
      35,    18,    34,    -1,    35,     6,    34,    -1,    35,     7,
      34,    -1,    35,    -1,    36,     8,    35,    -1,    36,     9,
      35,    -1,    36,    -1,    37,    16,    36,    -1,    37,    -1,
      38,    15,    37,    -1,    38,    -1,    39,    14,    38,    -1,
      39,    -1,    40,    10,    39,    -1,    40,    -1,    41,    11,
      40,    -1,    41,    -1,    41,    12,    42,    13,    42,    -1,
      42,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    93,    93,    98,   101,   102,   103,   113,   128,   129,
     142,   160,   180,   181,   194,   209,   210,   223,   238,   239,
     252,   265,   278,   293,   294,   307,   322,   323,   338,   339,
     354,   355,   370,   371,   386,   387,   402,   403,   419
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUM", "\"<<\"", "\">>\"", "\"<=\"",
  "\">=\"", "\"==\"", "\"!=\"", "\"&&\"", "\"||\"", "'?'", "':'", "'|'",
  "'^'", "'&'", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'",
  "UNEG", "UPLUS", "'('", "')'", "$accept", "primary", "unary", "mult",
  "add", "shift", "relation", "equal", "band", "bxor", "bor", "land",
  "lor", "cond", "expression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,    63,    58,   124,    94,    38,    60,    62,    43,
      45,    42,    47,    37,    33,   267,   268,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    29,    30,    30,    31,    31,    31,    31,    32,    32,
      32,    32,    33,    33,    33,    34,    34,    34,    35,    35,
      35,    35,    35,    36,    36,    36,    37,    37,    38,    38,
      39,    39,    40,    40,    41,    41,    42,    42,    43
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     3,     1,     2,     2,     2,     1,     3,
       3,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     5,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     2,     0,     0,     0,     0,     4,     8,    12,    15,
      18,    23,    26,    28,    30,    32,    34,    36,    38,     0,
       5,     6,     7,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     3,     9,    10,    11,    13,    14,
      16,    17,    21,    22,    19,    20,    24,    25,    27,    29,
      31,    33,    35,     0,     0,    37
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -24
static const yysigned_char yypact[] =
{
       2,   -24,     2,     2,     2,     2,   -24,   -24,    -9,    -4,
      15,     0,    19,   -12,    21,    16,    25,    20,   -24,    42,
     -24,   -24,   -24,    17,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   -24,   -24,   -24,   -24,   -24,    -9,    -9,
      -4,    -4,    15,    15,    15,    15,     0,     0,    19,   -12,
      21,    16,    25,    30,     2,   -24
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -24,   -24,    -1,     6,     9,   -23,     5,     7,     8,    10,
      11,    12,   -24,    -5,   -24
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      23,    20,    21,    22,    37,     1,    31,    32,    52,    53,
      54,    55,    24,    25,    26,    27,    28,    33,    34,    29,
      30,     2,     3,    45,    46,    47,     4,    35,    36,     5,
      39,    41,    42,    48,    49,    40,    38,    63,    50,    51,
      56,    57,    43,    64,    58,    44,    59,     0,     0,    60,
       0,    61,     0,    62,     0,     0,     0,     0,     0,    65
};

static const yysigned_char yycheck[] =
{
       5,     2,     3,     4,    16,     3,     6,     7,    31,    32,
      33,    34,    21,    22,    23,    19,    20,    17,    18,     4,
       5,    19,    20,    24,    25,    26,    24,     8,     9,    27,
      14,    11,    12,    27,    28,    10,    15,    42,    29,    30,
      35,    36,     0,    13,    37,    28,    38,    -1,    -1,    39,
      -1,    40,    -1,    41,    -1,    -1,    -1,    -1,    -1,    64
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    19,    20,    24,    27,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      31,    31,    31,    42,    21,    22,    23,    19,    20,     4,
       5,     6,     7,    17,    18,     8,     9,    16,    15,    14,
      10,    11,    12,     0,    28,    31,    31,    31,    32,    32,
      33,    33,    34,    34,    34,    34,    35,    35,    36,    37,
      38,    39,    40,    42,    13,    42
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 94 "../main/expr_parse.y"
    { 
			  if ((yyval).err != 0)
			    YYABORT;
			}
    break;

  case 6:
#line 104 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c->code == E_VAL)
		    c->v.val = -c->v.val;
		  else
		    expre_add_op (pi_, E_NEG);
		}
    break;

  case 7:
#line 114 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c->code == E_VAL)
		    c->v.val = !c->v.val;
		  else
		    expre_add_op (pi_, E_NOT);
		}
    break;

  case 9:
#line 130 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val *= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_MUL);
		}
    break;

  case 10:
#line 143 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      if (c->v.val == 0)
			{
			  expre_error ("division by zero");
			  YYABORT;
			}
		      c[-1].v.val /= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_DIV);
		}
    break;

  case 11:
#line 161 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      if (c->v.val == 0)
			{
			  expre_error ("division by zero");
			  YYABORT;
			}
		      c[-1].v.val %= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_MOD);
		}
    break;

  case 13:
#line 182 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val += c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_ADD);
		}
    break;

  case 14:
#line 195 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val -= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_SUB);
		}
    break;

  case 16:
#line 211 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val <<= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_LSH);
		}
    break;

  case 17:
#line 224 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val >>= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_RSH);
		}
    break;

  case 19:
#line 240 "../main/expr_parse.y"
    {
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val < c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_LT);
			}
    break;

  case 20:
#line 253 "../main/expr_parse.y"
    {
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val > c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_GT);
			}
    break;

  case 21:
#line 266 "../main/expr_parse.y"
    {
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val <= c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_LE);
			}
    break;

  case 22:
#line 279 "../main/expr_parse.y"
    {
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val >= c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_GE);
			}
    break;

  case 24:
#line 295 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val == c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		  expre_add_op (pi_, E_EQ);
		}
    break;

  case 25:
#line 308 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val != c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_NE);
		}
    break;

  case 27:
#line 324 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val &= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_BAND);
		}
    break;

  case 29:
#line 340 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val ^= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_BXOR);
		}
    break;

  case 31:
#line 356 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val |= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_BOR);
		}
    break;

  case 33:
#line 372 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val && c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_LAND);
		}
    break;

  case 35:
#line 388 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val || c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_LOR);
		}
    break;

  case 37:
#line 404 "../main/expr_parse.y"
    {
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 2;
		  if (c[-1].code == E_VAL && c->code == E_VAL
		      && c[1].code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val ? c->v.val : c[1].v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_COND);
		}
    break;

  case 38:
#line 420 "../main/expr_parse.y"
    { expre_add_op (pi_, E_END); }
    break;


    }

/* Line 1037 of yacc.c.  */
#line 1475 "main/expr_parse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 423 "../main/expr_parse.y"


/* Add *CODE to expression */
static void
expre_add (struct pi *pi, const struct expr_code *code)
{
  if (pi->code == pi->end)
    {
      struct expr_code *copy;
      size_t size;

      size = 2 * (pi->end - pi->start);
      copy = xrealloc (pi->start, size * sizeof (*pi->start));
      pi->code = copy + (pi->code - pi->start);
      pi->end = copy + size;
      pi->start = copy;
    }
  *pi->code++ = *code;
}

/* Add OP to expression */
static void
expre_add_op (struct pi *pi, int op)
{
  struct expr_code code;

  code.code = op;
  expre_add (pi, &code);
}

static void
expre_error (const char *s)
{
  error (0, "%s", s);
}

/* Is C a hexadecimal digit? */
static int
is_hex_digit (char c)
{
  static const char valid[22] = "0123456789ABCDEFabcdef";

  return memchr (valid, c, sizeof (valid)) != NULL;
}

/* If we set lvalp->err = 1 in one of the parsing functions, we can leave
   pi->expr pointing anywhere, because as soon as we return to the parser,
   the parser aborts and pi->expr is not used again. */

/* Parse a character constant from PI to LVALP */
inline static void
parse_char_constant (YYSTYPE *lvalp, struct pi *pi)
{
  struct expr_code code;
  intmax_t val;
  char c;

  c = *pi->expr++;
  switch (c)
    {
    case '\'':
      expre_error ("empty character constant");
      lvalp->err = 1;
      return;

    case 0:
      goto unterminated;
      
    default:
      val = (unsigned char)c;
      break;

    case '\\':
      switch (*pi->expr++)
	{
	case '\'': case '\"': case '\?': case '\\':
	  val = (unsigned char)pi->expr[-1];
	  break;

	case 'a':
	  val = '\a';
	  break;

	case 'b':
	  val = '\b';
	  break;

	case 'f':
	  val = '\f';
	  break;

	case 'n':
	  val = '\n';
	  break;

	case 't':
	  val = '\t';
	  break;

	case 'r':
	  val = '\r';
	  break;

	case 'v':
	  val = '\v';
	  break;

	case '0': case '1': case '2': case '3': case '4': case '5': case '6':
	case '7':
	  val = pi->expr[-1] - '0';
	  if (*pi->expr >= '0' && *pi->expr < '8')
	    {
	      val = val * 8 + *pi->expr++ - '0';
	      if (*pi->expr >= '0' && *pi->expr < '8')
		val = val * 8 + *pi->expr++ - '0';
	    }
	  break;

	case 'x':
	  if (!is_hex_digit (*pi->expr))
	    goto bad_hex;
	  val = 0;
	  do
	    {
	      unsigned digit;
	      
	      switch (*pi->expr++)
		{
		case '0': case '1': case '2': case '3': case '4': case '5':
		case '6': case '7': case '8': case '9':
		  digit = pi->expr[-1] - '0';
		  break;

		case 'A': case 'a':
		  digit = 10;
		  break;
		case 'B': case 'b':
		  digit = 11;
		  break;
		case 'C': case 'c':
		  digit = 12;
		  break;
		case 'D': case 'd':
		  digit = 13;
		  break;
		case 'E': case 'e':
		  digit = 14;
		  break;
		case 'F': case 'f':
		  digit = 15;
		  break;

		default:
		  assert ("BUG" == NULL);
		  goto bad_hex;
		}
	      if (val > INTMAX_MAX / 16
		  || (val == INTMAX_MAX / 16 && digit > INTMAX_MAX % 16))
		goto bad_hex;
	      val = val * 16 + digit;
	    }
	  while (is_hex_digit (*pi->expr));
	  break;

	default:
	  expre_error ("invalid excape sequence");
	  lvalp->err = 1;
	  return;
	}
      break;
    }
  if (*pi->expr++ != '\'')
    goto unterminated;
  lvalp->err = 0;
  code.code = E_VAL;
  code.v.val = val;
  expre_add (pi, &code);
  return;

 bad_hex:
  expre_error ("invalid hexadecimal escape sequence");
  lvalp->err = 1;
  return;

 unterminated:
  expre_error ("unterminated character constant");
  lvalp->err = 1;
}

/* Parse a port value reference from PI to LVALP.  In case this never gets
   documented ;-), the expected format is [PORT] or [c:PORT] if you want to
   reference the port in evaluate/modify, but don't want to assign to it. */
static void
parse_port (YYSTYPE *lvalp, struct pi *pi)
{
  struct expr_code code;
  char *end;
  size_t len;

  if (*pi->expr == 'c' && pi->expr[1] == ':')
    {
      pi->expr += 2;
      code.code = E_CPORT;
    }
  else
    code.code = E_PORT;
  /* FIXME: provide a way to define aliases */
  errno = 0;
  end = strchr (pi->expr, ']');
  if (end == NULL)
    {
      expre_error ("unterminated port reference");
      lvalp->err = 1;
      return;
    }
  len = end - pi->expr;
  {
    char copy[len + 1];
    struct port_id id;

    memcpy (copy, pi->expr, len);
    copy[len] = 0;
    code.v.port.width = get_port_width (port_find (NUM_WIDTHS, copy, &id));
    if (code.v.port.width == NUM_WIDTHS)
      {
	lvalp->err = 1;
	return;
      }
    switch (code.v.port.width)
      {
#define DO_TYPE(WIDTH, TYPE)						\
       case WIDTH_##WIDTH:						\
	{								\
	  TYPE val;							\
									\
	  if (((pi->flags & EC_MODIFY) == 0 || code.code == E_CPORT)	\
	      && port_disp_##WIDTH (&id, &val) != 0)			\
	    {								\
	      lvalp->err = 1;						\
	      return;							\
	    }								\
	  if ((pi->flags & EC_VALUE) == 0)				\
	    code.v.port.pi = id;					\
	  else								\
	    {								\
	      code.code = E_VAL;					\
	      code.v.val = val;						\
	    }								\
	  break;							\
	}
	DO_TYPE (1, int);
	DO_TYPE (8, uint8_t);
	DO_TYPE (16, uint16_t);

      default:
	assert ("BUG" == NULL);
#undef DO_TYPE
      }
  }
  pi->expr = end + 1;
  lvalp->err = 0;
  expre_add (pi, &code);
}

static int
expre_lex (YYSTYPE *lvalp, void *pi_)
{
  struct pi *pi;
  char c;

  pi = pi_;
  while ((c = *pi->expr++) != 0)
    {
      switch (c)
	{
	case ' ': case '\t': case '\n': case '\v': case '\f':
	  break; /* Ignore */

	case '0': case '1': case '2': case '3': case '4': case '5': case '6':
	case '7': case '8': case '9':
	  {
	    char *end;
	    struct expr_code code;

	    pi->expr--; /* Back to the first digit */
	    errno = 0;
	    code.v.val = strtoimax (pi->expr, &end, 0);
	    if (end == pi->expr || errno != 0)
	      {
		expre_error ("invalid integer constant");
		lvalp->err = 1;
		return NUM;
	      }
	    pi->expr = end;
	    lvalp->err = 0;
	    code.code = E_VAL;
	    expre_add (pi, &code);
	    return NUM;
	  }

	case '\'': /* L' ' not supported */
	  parse_char_constant (lvalp, pi);
	  return NUM;

	case '[':
	  parse_port (lvalp, pi);
	  return NUM;

#define CHECK(CHAR, SYM)			\
	  if (*pi->expr == CHAR)		\
	    {					\
	      pi->expr++;			\
	      return SYM;			\
	    }
	case '!':
	  CHECK ('=', NEQ);
	  return c;
	  
	case '&':
	  CHECK ('&', LAND);
	  return c;

	case '<':
	  CHECK ('<', LSH);
	  CHECK ('=', LEQ);
	  return c;

	case '=':
	  CHECK ('=', EQ);
	  return c;
	  
	case '>':
	  CHECK ('>', RSH);
	  CHECK ('=', GEQ);
	  return c;

	case '|':
	  CHECK ('|', LOR);
	  return c;
#undef CHECK
	  
	case 0: case '%': case '(': case ')': case '*': case '+': case '-':
	case '/': case ':': case '?': case '^': default:
	  return c;
	}
      
    }
  return 0;
}

/* Evaluate EXPR, store result to DEST;
   returns: 0 if OK, -1 on error */
int
expr_eval (const char *expr, intmax_t *dest)
{
  struct pi pi;
  int res;

  pi.expr = expr;
  pi.start = xmalloc (8 * sizeof (*pi.start));
  pi.code = pi.start;
  pi.end = pi.start + 8;
  pi.flags = EC_VALUE;
  if (expre_parse (&pi) != 0)
    {
      res = -1;
      goto err;
    }
  assert (pi.start->code == E_VAL && pi.start[1].code == E_END);
  *dest = pi.start->v.val;
  res = 0;
 err:
  free (pi.start);
  return res;
}

/* Compile EXPR according to FLAGS (see EC_* below);
   returns: expression (for free ()) if OK, NULL on error */
struct expr_code *
expr_compile (const char *expr, unsigned flags)
{
  struct pi pi;

  pi.expr = expr;
  pi.start = xmalloc (8 * sizeof (*pi.start));
  pi.code = pi.start;
  pi.end = pi.start + 8;
  pi.flags = flags;
  if (expre_parse (&pi) == 0)
    {
      pi.start = xrealloc (pi.start,
			   (pi.code - pi.start) * sizeof (*pi.start));
      return pi.start;
    }
  free (pi.start);
  return NULL;
}


